/* DCF77 decoding routines
 * The function clock_decode() must be called from the @input()
 * function, which the main script must implement. See the
 * application note for details:
 *    http://www.compuphase.com/mp3/h0420_timecode.htm
 */

#if defined _clock_included
    #endinput
#endif
#define _clock_included

const pulsemargin = 30  /* margin in milliseconds */

static dcf_pin          /* the input pin number */
static dcf_timestamp
static dcf_pulsetime
static dcf_pulses[59 char]
static dcf_index = 0

clock_init(power_pin, data_pin)
    {
    configiopin power_pin, Output
    setiopin power_pin, 1

    configiopin data_pin, Input
    dcf_pin = data_pin  /* save, for testing it later */

    dcf_index = 0
    }

bool: clock_decode(pin, status)
    {
    new bool: updated = false

    if (pin != dcf_pin)
        return false

    if (status)
        {
        dcf_timestamp = tickcount()
        return false
        }

    /* check the width of the pulse; according to the specifications, a
     * pulse must be 0.1 or 0.2 seconds
     */
    new pulsewidth = tickcount() - dcf_timestamp
    new islong = (200 - pulsemargin) <= pulsewidth <= (200 + pulsemargin)
    new isshort = (100 - pulsemargin) <= pulsewidth <= (100 + pulsemargin)
    if (islong || isshort)
        {
        /* pulse has a valid length, now check for a minute marker */
        if (1500 <= dcf_timestamp - dcf_pulsetime <= 2500)
            {
            new minute, hour, day, month, year
            /* if we got 59 items in the array, we can decode the array */
            if (dcf_index == 59 && dcf_pulses{20})
                {
                /* extract the time */
                minute = dcf_pulses{21}
                         + 2 * dcf_pulses{22}
                         + 4 * dcf_pulses{23}
                         + 8 * dcf_pulses{24}
                         + 10 * dcf_pulses{25}
                         + 20 * dcf_pulses{26}
                         + 40 * dcf_pulses{27}
                hour = dcf_pulses{29}
                         + 2 * dcf_pulses{30}
                         + 4 * dcf_pulses{31}
                         + 8 * dcf_pulses{32}
                         + 10 * dcf_pulses{33}
                         + 20 * dcf_pulses{34}
                day = dcf_pulses{36}
                         + 2 * dcf_pulses{37}
                         + 4 * dcf_pulses{38}
                         + 8 * dcf_pulses{39}
                         + 10 * dcf_pulses{40}
                         + 20 * dcf_pulses{41}
                month = dcf_pulses{45}
                         + 2 * dcf_pulses{46}
                         + 4 * dcf_pulses{47}
                         + 8 * dcf_pulses{48}
                         + 10 * dcf_pulses{49}
                year = dcf_pulses{50}
                         + 2 * dcf_pulses{51}
                         + 4 * dcf_pulses{52}
                         + 8 * dcf_pulses{53}
                         + 10 * dcf_pulses{54}
                         + 20 * dcf_pulses{55}
                         + 40 * dcf_pulses{56}
                         + 80 * dcf_pulses{57}
                         + 2000

                setdate year, month, day
                settime hour, minute, 0
                updated = true
                }
            dcf_index = 0
            }
        dcf_pulsetime = dcf_timestamp
        if (dcf_index < 59)
            dcf_pulses{dcf_index} = islong
        dcf_index++
        }

    return updated
    }
